diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/mesh-wifi-interface-mac.cc ns-3.36/src/mesh/model/mesh-wifi-interface-mac.cc
--- ns-3.35/src/mesh/model/mesh-wifi-interface-mac.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/mesh-wifi-interface-mac.cc	2022-04-30 18:23:58.078734600 -0700
@@ -33,6 +33,8 @@
 #include "ns3/socket.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/channel-access-manager.h"
+#include "ns3/mac-tx-middle.h"
+#include "ns3/qos-txop.h"
 
 namespace ns3 {
 
@@ -44,7 +46,7 @@
 MeshWifiInterfaceMac::GetTypeId ()
 {
   static TypeId tid = TypeId ("ns3::MeshWifiInterfaceMac")
-    .SetParent<RegularWifiMac> ()
+    .SetParent<WifiMac> ()
     .SetGroupName ("Mesh")
     .AddConstructor<MeshWifiInterfaceMac> ()
     .AddAttribute ( "BeaconInterval",
@@ -88,6 +90,11 @@
 //-----------------------------------------------------------------------------
 // WifiMac inherited
 //-----------------------------------------------------------------------------
+bool
+MeshWifiInterfaceMac::CanForwardPacketsTo (Mac48Address to) const
+{
+  return true;
+}
 void
 MeshWifiInterfaceMac::Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from)
 {
@@ -109,7 +116,7 @@
 MeshWifiInterfaceMac::SetLinkUpCallback (Callback<void> linkUp)
 {
   NS_LOG_FUNCTION (this);
-  RegularWifiMac::SetLinkUpCallback (linkUp);
+  WifiMac::SetLinkUpCallback (linkUp);
 
   // The approach taken here is that, from the point of view of a mesh
   // node, the link is always up, so we immediately invoke the
@@ -123,7 +130,7 @@
   m_plugins.clear ();
   m_beaconSendEvent.Cancel ();
 
-  RegularWifiMac::DoDispose ();
+  WifiMac::DoDispose ();
 }
 void
 MeshWifiInterfaceMac::DoInitialize ()
@@ -176,15 +183,15 @@
 MeshWifiInterfaceMac::GetFrequencyChannel () const
 {
   NS_LOG_FUNCTION (this);
-  NS_ASSERT (m_phy != 0); // need PHY to set/get channel
-  return m_phy->GetChannelNumber ();
+  NS_ASSERT (GetWifiPhy () != 0); // need PHY to set/get channel
+  return GetWifiPhy ()->GetChannelNumber ();
 }
 
 void
 MeshWifiInterfaceMac::SwitchFrequencyChannel (uint16_t new_id)
 {
   NS_LOG_FUNCTION (this);
-  NS_ASSERT (m_phy != 0); // need PHY to set/get channel
+  NS_ASSERT (GetWifiPhy () != 0); // need PHY to set/get channel
   /**
    * \todo
    * Correct channel switching is:
@@ -196,7 +203,7 @@
    *
    * Now we use dirty channel switch -- just change frequency
    */
-  m_phy->SetChannelNumber (new_id);
+  GetWifiPhy ()->SetOperatingChannel (WifiPhy::ChannelTuple {new_id, 0, GetWifiPhy ()->GetPhyBand (), 0});
   // Don't know NAV on new channel
   m_channelAccessManager->NotifyNavResetNow (Seconds (0));
 }
@@ -232,15 +239,15 @@
   // Assert that address1 is set. Assert will fail e.g. if there is no installed routing plugin.
   NS_ASSERT (hdr.GetAddr1 () != Mac48Address ());
   // Queue frame
-  if (m_stationManager->IsBrandNew (hdr.GetAddr1 ()))
+  if (GetWifiRemoteStationManager ()->IsBrandNew (hdr.GetAddr1 ()))
     {
       // in adhoc mode, we assume that every destination
       // supports all the rates we support.
-      for (const auto & mode : m_phy->GetModeList ())
+      for (const auto & mode : GetWifiPhy ()->GetModeList ())
         {
-          m_stationManager->AddSupportedMode (hdr.GetAddr1 (), mode);
+          GetWifiRemoteStationManager ()->AddSupportedMode (hdr.GetAddr1 (), mode);
         }
-      m_stationManager->RecordDisassociated (hdr.GetAddr1 ());
+      GetWifiRemoteStationManager ()->RecordDisassociated (hdr.GetAddr1 ());
     }
   // Classify: application may have set a tag, which is removed here
   AcIndex ac;
@@ -258,8 +265,8 @@
     }
   m_stats.sentFrames++;
   m_stats.sentBytes += packet->GetSize ();
-  NS_ASSERT (m_edca.find (ac) != m_edca.end ());
-  m_edca[ac]->Queue (packet, hdr);
+  NS_ASSERT (GetQosTxop (ac) != nullptr);
+  GetQosTxop (ac)->Queue (packet, hdr);
 }
 void
 MeshWifiInterfaceMac::SendManagementFrame (Ptr<Packet> packet, const WifiMacHeader& hdr)
@@ -276,7 +283,7 @@
     }
   m_stats.sentFrames++;
   m_stats.sentBytes += packet->GetSize ();
-  if ((m_edca.find (AC_VO) == m_edca.end ()) || (m_edca.find (AC_BK) == m_edca.end ()))
+  if ((GetQosTxop (AC_VO) == nullptr) || (GetQosTxop (AC_BK) == nullptr))
     {
       NS_FATAL_ERROR ("Voice or Background queue is not set up!");
     }
@@ -290,11 +297,11 @@
    */
   if (hdr.GetAddr1 () != Mac48Address::GetBroadcast ())
     {
-      m_edca[AC_VO]->Queue (packet, header);
+      GetQosTxop (AC_VO)->Queue (packet, header);
     }
   else
     {
-      m_edca[AC_BK]->Queue (packet, header);
+      GetQosTxop (AC_BK)->Queue (packet, header);
     }
 }
 SupportedRates
@@ -303,28 +310,28 @@
   // set the set of supported rates and make sure that we indicate
   // the Basic Rate set in this set of supported rates.
   SupportedRates rates;
-  for (const auto & mode : m_phy->GetModeList ())
+  for (const auto & mode : GetWifiPhy ()->GetModeList ())
     {
-      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
-      rates.AddSupportedRate (mode.GetDataRate (m_phy->GetChannelWidth (), gi, 1));
+      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, GetWifiPhy ()->GetDevice ());
+      rates.AddSupportedRate (mode.GetDataRate (GetWifiPhy ()->GetChannelWidth (), gi, 1));
     }
   // set the basic rates
-  for (uint32_t j = 0; j < m_stationManager->GetNBasicModes (); j++)
+  for (uint32_t j = 0; j < GetWifiRemoteStationManager ()->GetNBasicModes (); j++)
     {
-      WifiMode mode = m_stationManager->GetBasicMode (j);
-      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
-      rates.SetBasicRate (mode.GetDataRate (m_phy->GetChannelWidth (), gi, 1));
+      WifiMode mode = GetWifiRemoteStationManager ()->GetBasicMode (j);
+      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, GetWifiPhy ()->GetDevice ());
+      rates.SetBasicRate (mode.GetDataRate (GetWifiPhy ()->GetChannelWidth (), gi, 1));
     }
   return rates;
 }
 bool
 MeshWifiInterfaceMac::CheckSupportedRates (SupportedRates rates) const
 {
-  for (uint32_t i = 0; i < m_stationManager->GetNBasicModes (); i++)
+  for (uint32_t i = 0; i < GetWifiRemoteStationManager ()->GetNBasicModes (); i++)
     {
-      WifiMode mode = m_stationManager->GetBasicMode (i);
-      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
-      if (!rates.IsSupportedRate (mode.GetDataRate (m_phy->GetChannelWidth (), gi, 1)))
+      WifiMode mode = GetWifiRemoteStationManager ()->GetBasicMode (i);
+      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, GetWifiPhy ()->GetDevice ());
+      if (!rates.IsSupportedRate (mode.GetDataRate (GetWifiPhy ()->GetChannelWidth (), gi, 1)))
         {
           return false;
         }
@@ -430,16 +437,16 @@
         {
           SupportedRates rates = beacon_hdr.GetSupportedRates ();
 
-          for (const auto & mode : m_phy->GetModeList ())
+          for (const auto & mode : GetWifiPhy ()->GetModeList ())
             {
-              uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
-              uint64_t rate = mode.GetDataRate (m_phy->GetChannelWidth (), gi, 1);
+              uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, GetWifiPhy ()->GetDevice ());
+              uint64_t rate = mode.GetDataRate (GetWifiPhy ()->GetChannelWidth (), gi, 1);
               if (rates.IsSupportedRate (rate))
                 {
-                  m_stationManager->AddSupportedMode (hdr->GetAddr2 (), mode);
+                  GetWifiRemoteStationManager ()->AddSupportedMode (hdr->GetAddr2 (), mode);
                   if (rates.IsBasicRate (rate))
                     {
-                      m_stationManager->AddBasicMode (mode);
+                      GetWifiRemoteStationManager ()->AddBasicMode (mode);
                     }
                 }
             }
@@ -472,9 +479,9 @@
       ForwardUp (packet, hdr->GetAddr4 (), hdr->GetAddr3 ());
     }
 
-  // We don't bother invoking RegularWifiMac::Receive() here, because
+  // We don't bother invoking WifiMac::Receive() here, because
   // we've explicitly handled all the frames we care about. This is in
-  // contrast to most classes which derive from RegularWifiMac.
+  // contrast to most classes which derive from WifiMac.
 }
 uint32_t
 MeshWifiInterfaceMac::GetLinkMetric (Mac48Address peerAddress)
@@ -540,13 +547,22 @@
 void
 MeshWifiInterfaceMac::ConfigureStandard (enum WifiStandard standard)
 {
-  SetQosSupported (true);  // a mesh station is a QoS station
-  RegularWifiMac::ConfigureStandard (standard);
+  NS_ABORT_IF (!GetQosSupported ());
+  WifiMac::ConfigureStandard (standard);
   m_standard = standard;
+}
 
+void
+MeshWifiInterfaceMac::ConfigureContentionWindow (uint32_t cwMin, uint32_t cwMax)
+{
+  WifiMac::ConfigureContentionWindow (cwMin, cwMax);
   // We use the single DCF provided by WifiMac for the purpose of
   // Beacon transmission. For this we need to reconfigure the channel
   // access parameters slightly, and do so here.
+  m_txop = CreateObject<Txop> ();
+  m_txop->SetChannelAccessManager (m_channelAccessManager);
+  m_txop->SetWifiMac (this);
+  m_txop->SetTxMiddle (m_txMiddle);
   m_txop->SetMinCw (0);
   m_txop->SetMaxCw (0);
   m_txop->SetAifsn (1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/mesh-wifi-interface-mac.h ns-3.36/src/mesh/model/mesh-wifi-interface-mac.h
--- ns-3.35/src/mesh/model/mesh-wifi-interface-mac.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/mesh-wifi-interface-mac.h	2022-04-30 18:23:58.078734600 -0700
@@ -29,7 +29,7 @@
 #include "ns3/callback.h"
 #include "ns3/packet.h"
 #include "ns3/nstime.h"
-#include "ns3/regular-wifi-mac.h"
+#include "ns3/wifi-mac.h"
 #include "ns3/mesh-wifi-interface-mac-plugin.h"
 #include "ns3/event-id.h"
 
@@ -47,7 +47,7 @@
  *  - management and priority traffic.
  *
  */
-class MeshWifiInterfaceMac : public RegularWifiMac
+class MeshWifiInterfaceMac : public WifiMac
 {
 public:
   /**
@@ -65,6 +65,7 @@
   virtual void  Enqueue (Ptr<Packet> packet, Mac48Address to);
   virtual bool  SupportsSendFrom () const;
   virtual void  SetLinkUpCallback (Callback<void> linkUp);
+  virtual bool CanForwardPacketsTo (Mac48Address to) const;
 
   /// \name Each mesh point interface must know the mesh point address
   ///@{
@@ -193,6 +194,15 @@
    */
   virtual void ConfigureStandard (enum WifiStandard standard);
   /**
+   * \param cwMin the minimum contention window size
+   * \param cwMax the maximum contention window size
+   *
+   * This method is called to set the minimum and the maximum
+   * contention window size.
+   */
+  virtual void ConfigureContentionWindow (uint32_t cwMin, uint32_t cwMax);
+
+  /**
    * Assign a fixed random variable stream number to the random variables
    * used by this model.  Return the number of streams (possibly zero) that
    * have been assigned.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/test/dot11s/hwmp-proactive-regression.cc ns-3.36/src/mesh/test/dot11s/hwmp-proactive-regression.cc
--- ns-3.35/src/mesh/test/dot11s/hwmp-proactive-regression.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/test/dot11s/hwmp-proactive-regression.cc	2022-04-30 18:23:58.078734600 -0700
@@ -56,8 +56,8 @@
 void
 HwmpProactiveRegressionTest::DoRun ()
 {
-  RngSeedManager::SetSeed (12345);
-  RngSeedManager::SetRun (7);
+  RngSeedManager::SetSeed (1);
+  RngSeedManager::SetRun (1);
   CreateNodes ();
   CreateDevices ();
   InstallApplications ();
@@ -113,19 +113,27 @@
   YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default ();
   Ptr<YansWifiChannel> chan = wifiChannel.Create ();
   wifiPhy.SetChannel (chan);
+  // This test was written prior to the preamble detection model
+  wifiPhy.DisablePreambleDetectionModel ();
 
   // 2. setup mesh
   MeshHelper mesh = MeshHelper::Default ();
+  // Due to the fact that MAC addresses are set by a local static variable
+  // that already allocates addresses to the previous tests in regression.cc,
+  // the first allocated address in this test will be 00:00:00:00:00:0b.
+  // (pmp allocates 2, simplest allocates 2, and reactive allocates 6)
+  // Therefore, the middle node will have address 00:00:00:00:00:0d,
+  // so we set this to the root as per the comment in the header file.
   mesh.SetStackInstaller ("ns3::Dot11sStack", "Root", Mac48AddressValue (Mac48Address ("00:00:00:00:00:0d")));
   mesh.SetMacType ("RandomStart", TimeValue (Seconds (0.1)));
   mesh.SetNumberOfInterfaces (1);
   NetDeviceContainer meshDevices = mesh.Install (wifiPhy, *m_nodes);
-  // Five devices, 9 streams per device 
+  // Five devices, 10 streams per device 
   streamsUsed += mesh.AssignStreams (meshDevices, streamsUsed);
-  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 9), "Stream mismatch");
-  // No streams used here, by default
+  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 10), "Stream mismatch");
+  // No streams used here, by default, so streamsUsed should not change
   streamsUsed += wifiChannel.AssignStreams (chan, streamsUsed);
-  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 9), "Stream mismatch");
+  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 10), "Stream mismatch");
 
   // 3. setup TCP/IP
   InternetStackHelper internetStack;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/test/dot11s/hwmp-proactive-regression.h ns-3.36/src/mesh/test/dot11s/hwmp-proactive-regression.h
--- ns-3.35/src/mesh/test/dot11s/hwmp-proactive-regression.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/test/dot11s/hwmp-proactive-regression.h	2022-04-30 18:23:58.078734600 -0700
@@ -30,11 +30,13 @@
  * \ingroup dot11s-test
  * \ingroup tests
  *
- * \brief There are 5 stations set into a column, the center station is root.
- * Regression test indicates, that traffic goes from the first to the
+ * \brief There are 5 stations set into a row, the center station is root.
+ * Regression test indicates that traffic goes from the first to the
  * last stations without reactive route discovery procedure
  * \verbatim
- * Src                Root                 Dst
+ *          Src                Root                 Dst
+ * (node ID) 0         1         2         3         4
+ * (MAC)   00:0b     00:0c     00:0d     00:0e     00:0f
  *           |         |<--------|-------->|         |          Proactive PREQ
  *           |         |-------->|         |         |          PREP
  *           |         |         |<--------|         |          PREP
@@ -45,14 +47,15 @@
  *  <--------|-------->|         |         |<--------|--------> Proactive PREQ
  *  Note, that at this moment all routes are known, and no reactive
  *  path discovery procedure shall be initiated
- *  <--------|-------->|         |         |         |          ARP request
- *           |.........|.........|.........|.........|
  *           |         |         |<--------|-------->|          ARP request
- *           |         |         |         |<--------|          ARP reply
  *           |.........|.........|.........|.........|
- *           |<--------|         |         |         |          ARP reply
- *           |-------->|         |         |         |          DATA
- *             ^ Further data is forwarded by proactive path
+ *  <--------|-------->|         |         |         |          ARP request
+ *           |-------->|         |         |         |          ARP reply
+ *           |.........|.........|.........|.........|
+ *           |         |         |         |-------->|          ARP reply
+ *           |         |         |         |<--------|          DATA
+ *                                             ^
+ *               Further data is forwarded by proactive path
  * \endverbatim
  *
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/test/dot11s/hwmp-reactive-regression.cc ns-3.36/src/mesh/test/dot11s/hwmp-reactive-regression.cc
--- ns-3.35/src/mesh/test/dot11s/hwmp-reactive-regression.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/test/dot11s/hwmp-reactive-regression.cc	2022-04-30 18:23:58.078734600 -0700
@@ -52,11 +52,7 @@
 void
 HwmpReactiveRegressionTest::DoRun ()
 {
-  RngSeedManager::SetSeed (12345);
-  // This test is somewhat sensitive to seed selection, since the nodes
-  // are on the fringe of reception range from one another (to create 
-  // a multi-hop topology).  Some seeds may yield no data transfer because
-  // ARP resolution across the mesh may fail too many times
+  RngSeedManager::SetSeed (1);
   RngSeedManager::SetRun (1);
   CreateNodes ();
   CreateDevices ();
@@ -77,11 +73,11 @@
   MobilityHelper mobility;
   Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
   positionAlloc->Add (Vector (  0,   0, 0));
-  positionAlloc->Add (Vector (  0, 150, 0));
-  positionAlloc->Add (Vector (  0, 300, 0));
-  positionAlloc->Add (Vector (  0, 450, 0));
+  positionAlloc->Add (Vector (  0, 120, 0));
+  positionAlloc->Add (Vector (  0, 240, 0));
+  positionAlloc->Add (Vector (  0, 360, 0));
+  positionAlloc->Add (Vector (  0, 480, 0));
   positionAlloc->Add (Vector (  0, 600, 0));
-  positionAlloc->Add (Vector (  0, 750, 0));
   mobility.SetPositionAllocator (positionAlloc);
   mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
   mobility.Install (*m_nodes);
@@ -114,6 +110,8 @@
   YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default ();
   Ptr<YansWifiChannel> chan = wifiChannel.Create ();
   wifiPhy.SetChannel (chan);
+  // This test was written prior to the preamble detection model
+  wifiPhy.DisablePreambleDetectionModel ();
 
   // 2. setup mesh
   MeshHelper mesh = MeshHelper::Default ();
@@ -121,11 +119,11 @@
   mesh.SetMacType ("RandomStart", TimeValue (Seconds (0.1)));
   mesh.SetNumberOfInterfaces (1);
   NetDeviceContainer meshDevices = mesh.Install (wifiPhy, *m_nodes);
-  // Six devices, 4 streams per device
+  // Six devices, 10 streams per device
   streamsUsed += mesh.AssignStreams (meshDevices, streamsUsed);
-  NS_TEST_EXPECT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 9), "Stream assignment mismatch");
+  NS_TEST_EXPECT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 10), "Stream assignment mismatch");
   streamsUsed += wifiChannel.AssignStreams (chan, streamsUsed);
-  NS_TEST_EXPECT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 9), "Stream assignment mismatch");
+  NS_TEST_EXPECT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 10), "Stream assignment mismatch");
 
   // 3. setup TCP/IP
   InternetStackHelper internetStack;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/test/dot11s/hwmp-reactive-regression.h ns-3.36/src/mesh/test/dot11s/hwmp-reactive-regression.h
--- ns-3.35/src/mesh/test/dot11s/hwmp-reactive-regression.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/test/dot11s/hwmp-reactive-regression.h	2022-04-30 18:23:58.078734600 -0700
@@ -34,33 +34,33 @@
  * Initiate scenario with 6 stations. Procedure of opening peer link
  * is the following: (PMP routines are not shown)
  * \verbatim
- *      1    2    3    4    5    6
- *      |    |    |    |    |<---|--->  ARP request (first attempt has failed!)
- *      |....|....|....|....|....|      ARP request
+ *      0    1    2    3    4    5 
+ *      |    |    |    |    |<---|--->  ARP request (2.002s)
+ *      |....|....|....|....|....|      ARP requests (continued)
  *      |<---|--->|    |    |    |      ARP request
  *  <---|--->|    |    |    |    |      PREQ       } This order is broken
  *  <---|--->|    |    |    |    |      ARP request} due to BroadcastDca 
- *      |<---|--->|    |    |    |      PREQ
+ *      |<---|--->|    |    |    |      PREQ 2.00468s)
  *      |....|....|....|....|....|      ARP request
- *      |    |    |    |<---|--->|      PREQ
+ *      |    |    |    |<---|--->|      PREQ (2.00621s)
  *      |    |    |    |    |<---|      PREP
- *      |....|....|....|....|....|      PREP 
- *      |<---|    |    |    |    |      PREP
- *      |--->|    |    |    |    |      ARP response
- *      |....|....|....|....|....|      ARP response
- *      |    |    |    |    |--->|      ARP response
- *      |    |    |    |    |<---|      Data
- *      |....|....|....|....|....|      Data
+ *      |....|....|....|....|....|      PREP (continued)
+ *      |<---|    |    |    |    |      PREP (2.00808s)
+ *      |--->|    |    |    |    |      ARP reply (2.0084s)
+ *      |....|....|....|....|....|      ARP replies
+ *      |    |    |    |    |--->|      ARP reply (2.01049s)
+ *      |    |    |    |    |<---|      Data (2.01059s)
+ *      |....|....|....|....|....|      Data (continued)
  *      |<---|    |    |    |    |      Data
- *  <---|--->|    |    |    |    |      ARP request
- *      |....|....|....|....|....|      ARP request
+ *  <---|--->|    |    |    |    |      ARP request (2.02076s)
+ *      |....|....|....|....|....|      ARP requests (continued)
  *      |    |    |    |    |<---|--->  ARP request
- *      |    |    |    |    |<---|      ARP response
- *      |....|....|....|....|....|      ARP response
- *      |<---|    |    |    |    |      ARP response
+ *      |    |    |    |    |<---|      ARP reply (2.02281s)
+ *      |....|....|....|....|....|      ARP replies (continued)
+ *      |<---|    |    |    |    |      ARP reply
  *      |--->|    |    |    |    |      Data
- * At 5 station number 4 disappears, and PERR is forwarded from 3 to 1
- * and from 5 to 6, and station 6 starts path discovery procedure
+ * At 5s, station number 3 disappears, and PERR is forwarded from 2 to 0
+ * and from 4 to 5, and station 5 starts path discovery procedure
  * again:
  *      |    |<---|         |--->|      PERR (one due to beacon loss and one due to TX error)
  *      |<---|    |         |    |      PERR
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/test/dot11s/hwmp-simplest-regression.cc ns-3.36/src/mesh/test/dot11s/hwmp-simplest-regression.cc
--- ns-3.35/src/mesh/test/dot11s/hwmp-simplest-regression.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/test/dot11s/hwmp-simplest-regression.cc	2022-04-30 18:23:58.078734600 -0700
@@ -55,8 +55,8 @@
 void
 HwmpSimplestRegressionTest::DoRun ()
 {
-  RngSeedManager::SetSeed (12345);
-  RngSeedManager::SetRun (7);
+  RngSeedManager::SetSeed (1);
+  RngSeedManager::SetRun (1);
   CreateNodes ();
   CreateDevices ();
   InstallApplications ();
@@ -129,11 +129,11 @@
   mesh.SetMacType ("RandomStart", TimeValue (Seconds (0.1)));
   mesh.SetNumberOfInterfaces (1);
   NetDeviceContainer meshDevices = mesh.Install (wifiPhy, *m_nodes);
-  // Two devices, nine streams per mesh device
+  // Two devices, ten streams per mesh device
   streamsUsed += mesh.AssignStreams (meshDevices, streamsUsed);
-  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 9), "Stream assignment mismatch");
+  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 10), "Stream assignment mismatch");
   streamsUsed += wifiChannel.AssignStreams (chan, streamsUsed);
-  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 9), "Stream assignment mismatch");
+  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 10), "Stream assignment mismatch");
 
   // 3. setup TCP/IP
   InternetStackHelper internetStack;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/test/dot11s/hwmp-simplest-regression.h ns-3.36/src/mesh/test/dot11s/hwmp-simplest-regression.h
--- ns-3.35/src/mesh/test/dot11s/hwmp-simplest-regression.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/test/dot11s/hwmp-simplest-regression.h	2022-04-30 18:23:58.078734600 -0700
@@ -34,27 +34,32 @@
  * Initiate scenario with 2 stations. Procedure of opening peer link
  * is the following:
  * \verbatim
+ *           server       client
  * <-----------|----------->   Broadcast frame
  *             |----------->|  Unicast frame
  *
  *                                        !!! PMP routines:
  * <-----------|----------->|             Beacon
- *             |<-----------|             Peer Link Open frame 
  *             |----------->|             Peer Link Open frame
- *             |----------->|             Peer Link Confirm frame
  *             |<-----------|             Peer Link Confirm frame
+ *             |<-----------|             Peer Link Open frame 
+ *             |----------->|             Peer Link Confirm frame
  *             |............|             !!! Data started:
- *             |<-----------|-----------> Arp Request
- * <-----------|----------->|             Arp Request (fwd)
+ *             |<-----------|-----------> ARP Request (time 2)
  * <-----------|----------->|             PREQ
  *             |<-----------|             PREP
  *             |----------->|             ARP reply
- *             |<-----------|             Data
+ * <-----------|----------->|             ARP Request (reflooded after delay)
+ *             |<-----------|             Data (first UDP datagram)
+ * <-----------|----------->|             ARP Request
+ *             |<-----------|             ARP reply
  *             |----------->|             Data
+ *             |<-----------|-----------> ARP Request (reflooded after delay)
  *             |............|             Some other beacons
  *             |<-----------|             Data
  *             |----------->|             Data
  *             |............|             !!! Route expiration routines:
+ *             |............|             !!! (after time 7)
  *             |<-----------|-----------> PREQ (route expired)
  *             |----------->|             PREP
  *             |<-----------|             Data
@@ -62,10 +67,8 @@
  *             |............|
  * \endverbatim
  * At 10 seconds stations become unreachable, so UDP client tries to
- * close peer link due to TX-fail, and UDP-srver tries to close link
+ * close peer link due to TX-fail, and UDP server tries to close peer link
  * due to beacon loss
-
-
  */
 class HwmpSimplestRegressionTest : public TestCase
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/test/dot11s/hwmp-target-flags-regression.cc ns-3.36/src/mesh/test/dot11s/hwmp-target-flags-regression.cc
--- ns-3.35/src/mesh/test/dot11s/hwmp-target-flags-regression.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/test/dot11s/hwmp-target-flags-regression.cc	2022-04-30 18:23:58.078734600 -0700
@@ -59,8 +59,8 @@
 void
 HwmpDoRfRegressionTest::DoRun ()
 {
-  RngSeedManager::SetSeed (12345);
-  RngSeedManager::SetRun (7);
+  RngSeedManager::SetSeed (1);
+  RngSeedManager::SetRun (1);
   CreateNodes ();
   CreateDevices ();
   InstallApplications ();
@@ -140,6 +140,8 @@
   YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default ();
   Ptr<YansWifiChannel> chan = wifiChannel.Create ();
   wifiPhy.SetChannel (chan);
+  // This scenario setup predates the preamble detection model
+  wifiPhy.DisablePreambleDetectionModel ();
 
   // 2. setup mesh
   MeshHelper mesh = MeshHelper::Default ();
@@ -147,11 +149,11 @@
   mesh.SetMacType ("RandomStart", TimeValue (Seconds (0.1)));
   mesh.SetNumberOfInterfaces (1);
   NetDeviceContainer meshDevices = mesh.Install (wifiPhy, *m_nodes);
-  // Four devices, nine streams per mac
+  // Four devices, ten streams per mac
   streamsUsed += mesh.AssignStreams (meshDevices, streamsUsed);
-  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 9), "Stream assignment mismatch");
+  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 10), "Stream assignment mismatch");
   streamsUsed += wifiChannel.AssignStreams (chan, streamsUsed);
-  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 9), "Stream assignment mismatch");
+  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 10), "Stream assignment mismatch");
 
   // 3. setup TCP/IP
   InternetStackHelper internetStack;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/test/dot11s/hwmp-target-flags-regression.h ns-3.36/src/mesh/test/dot11s/hwmp-target-flags-regression.h
--- ns-3.35/src/mesh/test/dot11s/hwmp-target-flags-regression.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/test/dot11s/hwmp-target-flags-regression.h	2022-04-30 18:23:58.078734600 -0700
@@ -35,7 +35,8 @@
  * \verbatim
  *  <-----------|----------->   Broadcast frame
  *              |----------->|  Unicast frame
- *            10          11            12           13
+ * (Node ID)   0           1             2            3
+ * (MAC addr) 10           11           12           13
  *             |            |<-----------|----------->|             ARP request (12 asks who has 10)
  *             |            |            |<-----------|-----------> ARP request
  *             |<-----------|----------->|            |             ARP request
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/test/dot11s/pmp-regression.cc ns-3.36/src/mesh/test/dot11s/pmp-regression.cc
--- ns-3.35/src/mesh/test/dot11s/pmp-regression.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/test/dot11s/pmp-regression.cc	2022-04-30 18:23:58.078734600 -0700
@@ -53,8 +53,8 @@
 void
 PeerManagementProtocolRegressionTest::DoRun ()
 {
-  RngSeedManager::SetSeed (12345);
-  RngSeedManager::SetRun (7);
+  RngSeedManager::SetSeed (1);
+  RngSeedManager::SetRun (1);
   CreateNodes ();
   CreateDevices ();
 
@@ -99,10 +99,10 @@
   mesh.SetMacType ("RandomStart", TimeValue (Seconds (0.1)));
   mesh.SetNumberOfInterfaces (1);
   NetDeviceContainer meshDevices = mesh.Install (wifiPhy, *m_nodes);
-  // Two devices, nine streams per device (one for mac, one for phy, 
-  // two for plugins, five for regular mac wifi DCF)
+  // Two devices, 10 streams per device (one for mac, one for phy, 
+  // two for plugins, five for regular mac wifi DCF, and one for MeshPointDevice)
   streamsUsed += mesh.AssignStreams (meshDevices, 0);
-  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 9), "Stream assignment mismatch");
+  NS_TEST_ASSERT_MSG_EQ (streamsUsed, (meshDevices.GetN () * 10), "Stream assignment mismatch");
   streamsUsed += wifiChannel.AssignStreams (chan, streamsUsed);
   // 3. write PCAP if needed
   wifiPhy.EnablePcapAll (CreateTempDirFilename (PREFIX));
